SystemOrganization addCategory: #'Pier-Blog-Model'!
SystemOrganization addCategory: #'Pier-Blog-Seaside'!

!PRStructure methodsFor: '*pier-blog-model-testing' stamp: 'lr 1/15/2007 21:06'!
isBlog
	^ false! !

!PRStructure methodsFor: '*pier-blog-model-testing' stamp: 'lr 1/14/2007 13:23'!
isComment
	^ false! !

!PRStructure methodsFor: '*pier-blog-model-testing' stamp: 'lr 1/14/2007 13:44'!
isPost
	^ false! !

!PRVisitor methodsFor: '*pier-blog-model' stamp: 'lr 1/15/2007 21:51'!
visitBlog: anObject
	self visitCase: anObject! !

!PRVisitor methodsFor: '*pier-blog-model' stamp: 'lr 1/15/2007 21:11'!
visitComment: anObject
	self visitEntry: anObject! !

!PRVisitor methodsFor: '*pier-blog-model' stamp: 'lr 1/15/2007 21:51'!
visitEntry: anObject
	self visitCase: anObject! !

!PRVisitor methodsFor: '*pier-blog-model' stamp: 'lr 1/15/2007 16:08'!
visitPost: anObject
	self visitEntry: anObject! !

PRViewRenderer subclass: #PBRssRenderer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Blog-Seaside'!

!PBRssRenderer methodsFor: 'visiting-document' stamp: 'lr 1/29/2007 23:31'!
visitAnchor: anObject! !

!PBRssRenderer methodsFor: 'visiting-links' stamp: 'lr 1/29/2007 23:33'!
visitInternalLinkBroken: anObject
	self visitLink: anObject! !

!PBRssRenderer methodsFor: 'visiting-links' stamp: 'lr 2/6/2007 18:47'!
visitInternalLinkGoto: anObject
	html anchor
		url: (self context structure: anObject target) url;
		with: [ self visitLink: anObject ]! !

!PBRssRenderer methodsFor: 'visiting-document' stamp: 'lr 2/5/2007 21:58'!
visitParagraph: anObject
	html paragraph: [ self visitAll: anObject children ]! !

!PRViewRenderer methodsFor: '*pier-blog-seaside-rendering' stamp: 'lr 1/21/2007 20:23'!
renderEntry: anEntry
	self renderEntryBody: anEntry.
	self renderEntryMeta: anEntry! !

!PRViewRenderer methodsFor: '*pier-blog-seaside-rendering' stamp: 'lr 1/21/2007 20:20'!
renderEntryBody: anEntry
	html div class: 'body'; with: [ self visit: anEntry document ]! !

!PRViewRenderer methodsFor: '*pier-blog-seaside-rendering' stamp: 'lr 2/12/2007 19:07'!
renderEntryMeta: anEntry
	| comments |
	comments := anEntry allCommentsIn: self context.
	html div class: 'meta'; with: [
		html text: 'Posted '.
		anEntry author ifNotNil: [
			html span
				class: 'author';
				with: 'by ' , anEntry author.
			html text: ' ' ].
		anEntry publication ifNotNil: [
			html span
				class: 'timestamp';
				with: 'at ' , anEntry publication date printString ,
					', ' , anEntry publication time printMinutes.
			html text: ' ' ].
		(anEntry isPost and: [ self context structure isBlog ]) ifTrue: [
			html anchor
				goto: (self context
					structure: (self context structure isBlog
						ifTrue: [ anEntry ]
						ifFalse: [ anEntry parent ]));
				with: comments size printString , ' comment' ,
					(comments size = 1 ifFalse: [ 's' ] ifTrue: [ '' ]).
			html text: ' ' ].
		html anchor
			url: (anEntry isPost
				ifTrue: [ (self context structure: anEntry) url ]
				ifFalse: [
					(self context
						structure: (anEntry parents reverse
							detect: [ :each | each isPost ]))
						url fragment: anEntry uuid ]);
			with: 'link' ]! !

!PRViewRenderer methodsFor: '*pier-blog-seaside-visiting' stamp: 'lr 2/6/2007 20:17'!
visitComment: anObject
	super visitComment: anObject.
	html div class: 'comment'; with: [ self renderEntry: anObject ]! !

!PRViewRenderer methodsFor: '*pier-blog-seaside-visiting' stamp: 'lr 2/6/2007 20:03'!
visitEntry: anObject
	html anchor name: anObject uuid! !

!PRViewRenderer methodsFor: '*pier-blog-seaside-visiting' stamp: 'lr 2/6/2007 20:17'!
visitPost: anObject
	super visitPost: anObject.
	html div class: 'post'; with: [ self renderEntry: anObject ]! !

PRWidget subclass: #PBPostTicker
	instanceVariableNames: 'blog posts numberOfPosts numberOfCharacters'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Blog-Seaside'!

!PBPostTicker class methodsFor: 'accessing-description' stamp: 'lr 2/7/2007 20:39'!
descriptionBlog
	^ (PRStructureDescription selector: #blog label: 'Source' priority: 100)
		addCondition: [ :value | value isBlog ] asCondition
		labelled: 'Select a blog as source';
		yourself! !

!PBPostTicker class methodsFor: 'accessing-description' stamp: 'lr 2/28/2007 07:59'!
descriptionNumberOfCharacters
	^ (MANumberDescription selector: #numberOfCharacters label: 'Number of Characters' priority: 110)
		addCondition: [ :value | value isInteger and: [ value positive ] ] labelled: 'Positive integer expected.';
		comment: 'The maximum number of characters to display of a post.';
		default: 200;
		yourself! !

!PBPostTicker class methodsFor: 'accessing-description' stamp: 'lr 2/28/2007 07:59'!
descriptionNumberOfPosts
	^ (MANumberDescription selector: #numberOfPosts label: 'Number of Posts' priority: 120)
		addCondition: [ :value | value isInteger and: [ value positive ] ] labelled: 'Positive integer expected.';
		comment: 'The maximum number of posts to appear.';
		default: 3;
		yourself! !

!PBPostTicker class methodsFor: 'testing' stamp: 'lr 2/7/2007 14:32'!
isAbstract
	^ false! !

!PBPostTicker class methodsFor: 'accessing' stamp: 'lr 2/7/2007 20:36'!
label
	^ 'Post Ticker'! !

!PBPostTicker methodsFor: 'accessing' stamp: 'lr 2/7/2007 11:41'!
blog
	^ blog! !

!PBPostTicker methodsFor: 'accessing' stamp: 'lr 2/7/2007 11:42'!
blog: aBlog
	blog := aBlog! !

!PBPostTicker methodsFor: 'private' stamp: 'lr 2/7/2007 11:53'!
findPosts
	| items |
	items := self blog allPostsIn: self context.
	self numberOfPosts isNil
		ifFalse: [ items := items last: (self numberOfPosts min: items size) ].
	^ items reversed! !

!PBPostTicker methodsFor: 'accessing' stamp: 'lr 2/7/2007 11:43'!
numberOfCharacters
	^ numberOfCharacters! !

!PBPostTicker methodsFor: 'accessing' stamp: 'lr 2/7/2007 11:43'!
numberOfCharacters: anInteger
	numberOfCharacters := anInteger! !

!PBPostTicker methodsFor: 'accessing' stamp: 'lr 2/7/2007 11:42'!
numberOfPosts
	^ numberOfPosts! !

!PBPostTicker methodsFor: 'accessing' stamp: 'lr 2/7/2007 11:43'!
numberOfPosts: anInteger
	numberOfPosts := anInteger! !

!PBPostTicker methodsFor: 'accessing-dynamic' stamp: 'lr 2/7/2007 20:35'!
posts
	^ posts ifNil: [ posts := self findPosts ]! !

!PBPostTicker methodsFor: 'rendering' stamp: 'lr 2/28/2007 07:58'!
renderContentOn: html
	self blog isNil 
		ifTrue: [ ^ html div: '(no blog specified)' ].
	self posts isEmpty
		ifTrue: [ ^ html div: '(no posts available)' ].
	html unorderedList class: 'postticker'; with: [
		self posts do: [ :each |
			html listItem: [
				self renderPost: each on: html ] ] ]! !

!PBPostTicker methodsFor: 'rendering' stamp: 'lr 2/28/2007 07:53'!
renderPost: aPost on: html
	html anchor
		goto: (self context structure: aPost);
		with: aPost title.
	html div 
		class: 'summary';
		with: (self summaryOf: aPost)! !

!PBPostTicker methodsFor: 'private' stamp: 'lr 2/28/2007 08:04'!
summaryOf: aPost
	| input output |
	input := (PRTextWriter write: aPost document) readStream.
	output := WriteStream on: String new.
	[ input atEnd ] whileFalse: [
		output nextPutAll: (input upTo: $<).
		input upTo: $> ].
	self numberOfCharacters ifNotNil: [
		output position: (output size min: self numberOfCharacters).
		output atEnd
			ifFalse: [ output nextPutAll: '...' ] ].
	^ output contents! !

PRRawView subclass: #PBRssView
	instanceVariableNames: 'blog'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Blog-Seaside'!

PBRssView subclass: #PBCommentsRssView
	instanceVariableNames: 'comments'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Blog-Seaside'!

!PBCommentsRssView class methodsFor: 'testing' stamp: 'lr 2/5/2007 19:56'!
isAbstract
	^ false! !

!PBCommentsRssView class methodsFor: 'accessing' stamp: 'lr 2/6/2007 20:00'!
label
	^ 'Comments (RSS)'! !

!PBCommentsRssView methodsFor: 'accessing' stamp: 'lr 2/5/2007 21:43'!
comments
	^ comments ifNil: [ comments := self findComments ]! !

!PBCommentsRssView methodsFor: 'private' stamp: 'lr 2/6/2007 18:26'!
findComments
	| items |
	items := self blog allCommentsIn: self context.
	^ items last: (self blog itemCount min: items size)! !

!PBCommentsRssView methodsFor: 'rendering' stamp: 'pmm 2/23/2007 09:00'!
renderComment: aComment on: rss
	| post |
	post := aComment parents reverse
		detect: [ :each | each isPost ].
	rss title: 'Comment on ' , post title.
	rss link: ((self context structure: post)
		url fragment: aComment uuid).
	aComment author
		ifNotNil: [ rss creator: aComment author ].
	rss publicationDate: (RRRfc822DateTime
		newDateAndTime: aComment publication).
	rss guid
		beNoPermaLink;
		with: aComment uuid.
	self renderDescription: aComment document on: rss! !

!PBCommentsRssView methodsFor: 'rendering' stamp: 'lr 2/5/2007 21:44'!
renderRssOn: rss
	super renderRssOn: rss.
	self comments isEmpty ifTrue: [ ^ self ].
	rss lastBuildDate: (RRRfc822DateTime
		newDateAndTime: self comments last publication).
	self comments do: [ :each |
		rss item: [ self renderComment: each on: rss ] ]! !

!PBCommentsRssView methodsFor: 'accessing-dynamic' stamp: 'lr 2/5/2007 21:46'!
title
	^ 'Comments for ' , super title! !

PBRssView subclass: #PBEntriesRssView
	instanceVariableNames: 'posts'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Blog-Seaside'!

!PBEntriesRssView class methodsFor: 'testing' stamp: 'lr 2/5/2007 19:55'!
isAbstract
	^ false! !

!PBEntriesRssView class methodsFor: 'accessing' stamp: 'lr 2/6/2007 20:00'!
label
	^ 'Entries (RSS)'! !

!PBEntriesRssView methodsFor: 'private' stamp: 'lr 2/5/2007 19:41'!
findPosts
	| items |
	items := self blog allPostsIn: self context.
	^ items last: (self blog itemCount min: items size)! !

!PBEntriesRssView methodsFor: 'accessing' stamp: 'lr 2/5/2007 21:42'!
posts
	^ posts ifNil: [ posts := self findPosts ]! !

!PBEntriesRssView methodsFor: 'rendering' stamp: 'pmm 2/23/2007 09:08'!
renderPost: aPost on: rss
	rss title: aPost title.
	rss link: (self context structure: aPost) url.
	rss comments: (self context structure: aPost) url.
	rss commentRss: (self context
			structure: self blog
			view: PBCommentsRssView) url.
	rss publicationDate: (RRRfc822DateTime
		newDateAndTime: aPost publication).
	self renderDescription: aPost document on: rss.
	aPost author
		ifNotNil: [ rss creator: aPost author ].
	rss guid
		beNoPermaLink;
		with: aPost uuid.
	aPost enclosure ifNotNilDo: [ :value |
		rss enclosure
			url: (value file urlOn: rss);
			length: value file filesize;
			type: value file mimetype ].
	aPost sourceUrl ifNotNil: [
		rss source
			url: aPost sourceUrl;
			with: aPost sourceTitle ]! !

!PBEntriesRssView methodsFor: 'rendering' stamp: 'lr 2/5/2007 21:42'!
renderRssOn: rss
	super renderRssOn: rss.
	self posts isEmpty ifTrue: [ ^ self ].
	rss lastBuildDate: (RRRfc822DateTime
		newDateAndTime: self posts last publication).
	self posts do: [ :each |
		rss item: [ self renderPost: each on: rss ] ]! !

!PBRssView class methodsFor: 'testing' stamp: 'lr 2/5/2007 19:55'!
isAbstract
	^ true! !

!PBRssView class methodsFor: 'testing' stamp: 'lr 2/6/2007 18:23'!
isValidIn: aContext
	^ (super isValidIn: aContext) and: [ aContext structure isBlog ]! !

!PBRssView class methodsFor: 'accessing' stamp: 'lr 2/6/2007 20:00'!
label
	^ 'Deprecated (RSS)'! !

!PBRssView class methodsFor: 'instance-creation' stamp: 'lr 2/12/2007 19:07'!
new
	"This is an ugly hack to make already bookmarked blogs work properly."

	^ self name = #PBRssView
		ifTrue: [ PBEntriesRssView new ]
		ifFalse: [ super new ]! !

!PBRssView methodsFor: 'accessing' stamp: 'lr 2/5/2007 19:39'!
blog
	^ blog ifNil: [ blog := self find: PBBlog ]! !

!PBRssView methodsFor: 'accessing-dynamic' stamp: 'lr 2/5/2007 21:35'!
link
	^ (self context structure: self blog) url! !

!PBRssView methodsFor: 'rendering' stamp: 'pmm 3/4/2007 09:42'!
renderDescription: aDocument on: rss
	| html |
	rss description: [ rss cdata: (PRTextWriter write: aDocument) ].
	rss contentEncoded with: [
		rss html: '<!![CDATA['.
		html := WARenderCanvas
			context: rss context
			callbacks: Dictionary new.
		PBRssRenderer new
			start: aDocument
			in: self on: html.
		html close.
		rss html: ']]>' ]! !

!PBRssView methodsFor: 'rendering' stamp: 'lr 2/12/2007 19:07'!
renderRssOn: rss
	"Generate some standard information that should be present in all the feeds."

	rss title: self title; link: self link.
	self renderDescription: self blog document on: rss.
	rss generator: PRDistribution productName.
	rss language: self blog language.
	self blog copyright
		ifNotNil: [ rss copyright: self blog copyright ].
	self blog managingEditor
		ifNotNil: [ rss managingEditor: self blog managingEditor ].
	self blog webMaster
		ifNotNil: [ rss webMaster: self blog webMaster ]! !

!PBRssView methodsFor: 'processing' stamp: 'pmm 2/23/2007 09:15'!
renderWithContext: aContext
	| response document |
	response := WAResponse new contentType: 'application/rss+xml'.
	document := RRRssStreamDocument root: RRRssRoot new.
	document stream: response stream.
	[ self renderRssOn: (RRRssRenderCanvas
		context: (aContext document: document)
		callbacks: Dictionary new) ]
		on: Error do: [ :err | response := WAResponse internalError: err ].
	document close.
	self session expire; returnResponse: response! !

!PBRssView methodsFor: 'accessing-dynamic' stamp: 'lr 2/5/2007 21:25'!
title
	^ self blog feedTitle ifNil: [ self blog title ]! !

PRCase subclass: #PBBlog
	instanceVariableNames: 'managingEditor webMaster copyright language itemCount feedTitle commentTimeout'
	classVariableNames: 'Languages'
	poolDictionaries: ''
	category: 'Pier-Blog-Model'!

!PBBlog class methodsFor: 'private' stamp: 'lr 1/26/2007 00:48'!
buildLanguages
	^ Dictionary new
		at: 'af' put: 'Afrikaans';
		at: 'sq' put: 'Albanian';
		at: 'eu' put: 'Basque';
		at: 'be' put: 'Belarusian';
		at: 'bg' put: 'Bulgarian';
		at: 'ca' put: 'Catalan';
		at: 'zh-cn' put: 'Chinese (Simplified)';
		at: 'zh-tw' put: 'Chinese (Traditional)';
		at: 'hr' put: 'Croatian';
		at: 'cs' put: 'Czech';
		at: 'da' put: 'Danish';
		at: 'nl' put: 'Dutch';
		at: 'nl-be' put: 'Dutch (Belgium)';
		at: 'nl-nl' put: 'Dutch (Netherlands)';
		at: 'en' put: 'English';
		at: 'en-au' put: 'English (Australia)';
		at: 'en-bz' put: 'English (Belize)';
		at: 'en-ca' put: 'English (Canada)';
		at: 'en-ie' put: 'English (Ireland)';
		at: 'en-jm' put: 'English (Jamaica)';
		at: 'en-nz' put: 'English (New Zealand)';
		at: 'en-ph' put: 'English (Phillipines)';
		at: 'en-za' put: 'English (South Africa)';
		at: 'en-tt' put: 'English (Trinidad)';
		at: 'en-gb' put: 'English (United Kingdom)';
		at: 'en-us' put: 'English (United States)';
		at: 'en-zw' put: 'English (Zimbabwe)';
		at: 'et' put: 'Estonian';
		at: 'fo' put: 'Faeroese';
		at: 'fi' put: 'Finnish';
		at: 'fr' put: 'French';
		at: 'fr-be' put: 'French (Belgium)';
		at: 'fr-ca' put: 'French (Canada)';
		at: 'fr-fr' put: 'French (France)';
		at: 'fr-lu' put: 'French (Luxembourg)';
		at: 'fr-mc' put: 'French (Monaco)';
		at: 'fr-ch' put: 'French (Switzerland)';
		at: 'gl' put: 'Galician';
		at: 'gd' put: 'Gaelic';
		at: 'de' put: 'German';
		at: 'de-at' put: 'German (Austria)';
		at: 'de-de' put: 'German (Germany)';
		at: 'de-li' put: 'German (Liechtenstein)';
		at: 'de-lu' put: 'German (Luxembourg)';
		at: 'de-ch' put: 'German (Switzerland)';
		at: 'el' put: 'Greek';
		at: 'haw' put: 'Hawaiian';
		at: 'hu' put: 'Hungarian';
		at: 'is' put: 'Icelandic';
		at: 'in' put: 'Indonesian';
		at: 'ga' put: 'Irish';
		at: 'it' put: 'Italian';
		at: 'it-it' put: 'Italian (Italy)';
		at: 'it-ch' put: 'Italian (Switzerland)';
		at: 'ja' put: 'Japanese';
		at: 'ko' put: 'Korean';
		at: 'mk' put: 'Macedonian';
		at: 'no' put: 'Norwegian';
		at: 'pl' put: 'Polish';
		at: 'pt' put: 'Portuguese';
		at: 'pt-br' put: 'Portuguese (Brazil)';
		at: 'pt-pt' put: 'Portuguese (Portugal)';
		at: 'ro' put: 'Romanian';
		at: 'ro-mo' put: 'Romanian (Moldova)';
		at: 'ro-ro' put: 'Romanian (Romania)';
		at: 'ru' put: 'Russian';
		at: 'ru-mo' put: 'Russian (Moldova)';
		at: 'ru-ru' put: 'Russian (Russia)';
		at: 'sr' put: 'Serbian';
		at: 'sk' put: 'Slovak';
		at: 'sl' put: 'Slovenian';
		at: 'es' put: 'Spanish';
		at: 'es-ar' put: 'Spanish (Argentina)';
		at: 'es-bo' put: 'Spanish (Bolivia)';
		at: 'es-cl' put: 'Spanish (Chile)';
		at: 'es-co' put: 'Spanish (Colombia)';
		at: 'es-cr' put: 'Spanish (Costa Rica)';
		at: 'es-do' put: 'Spanish (Dominican Republic)';
		at: 'es-ec' put: 'Spanish (Ecuador)';
		at: 'es-sv' put: 'Spanish (El Salvador)';
		at: 'es-gt' put: 'Spanish (Guatemala)';
		at: 'es-hn' put: 'Spanish (Honduras)';
		at: 'es-mx' put: 'Spanish (Mexico)';
		at: 'es-ni' put: 'Spanish (Nicaragua)';
		at: 'es-pa' put: 'Spanish (Panama)';
		at: 'es-py' put: 'Spanish (Paraguay)';
		at: 'es-pe' put: 'Spanish (Peru)';
		at: 'es-pr' put: 'Spanish (Puerto Rico)';
		at: 'es-es' put: 'Spanish (Spain)';
		at: 'es-uy' put: 'Spanish (Uruguay)';
		at: 'es-ve' put: 'Spanish (Venezuela)';
		at: 'sv' put: 'Swedish';
		at: 'sv-fi' put: 'Swedish (Finland)';
		at: 'sv-se' put: 'Swedish (Sweden)';
		at: 'tr' put: 'Turkish';
		at: 'uk' put: 'Ukranian';
		yourself! !

!PBBlog class methodsFor: 'testing' stamp: 'lr 1/15/2007 22:02'!
canBeParentOf: aClass
	^ aClass includesBehavior: PBPost! !

!PBBlog class methodsFor: 'accessing-description' stamp: 'lr 2/6/2007 19:46'!
descriptionCommentTimeout
	^ (MADurationDescription selector: #commentTimeout label: 'Comment Timeout' priority: 170)
		comment: 'How long should it be possible to post comments.';
		beRequired;
		beEditable;
		yourself! !

!PBBlog class methodsFor: 'accessing-description' stamp: 'lr 2/1/2007 19:48'!
descriptionContents
	^ super descriptionContents
		label: 'Description';
		yourself! !

!PBBlog class methodsFor: 'accessing-description' stamp: 'lr 2/1/2007 11:07'!
descriptionCopyright
	^ (MAStringDescription selector: #copyright label: 'Copyright' priority: 150)
		comment: 'Copyright notice for content in the channel.';
		beEditable;
		yourself! !

!PBBlog class methodsFor: 'accessing-description' stamp: 'lr 2/1/2007 20:23'!
descriptionFeedTitle
	^ (MAStringDescription selector: #feedTitle label: 'Feed Title' priority: 110)
		comment: 'The title of the channel.';
		beEditable;
		yourself! !

!PBBlog class methodsFor: 'accessing-description' stamp: 'lr 2/1/2007 20:24'!
descriptionItemCount
	^ (MANumberDescription selector: #itemCount label: 'Item Count' priority: 170)
		comment: 'The number of items to appear in the feed.';
		addCondition: [ :value | value isInteger and: [ value positive ] ]
		labelled: 'Positive integer expected.';
		beRequired;
		beEditable;
		yourself! !

!PBBlog class methodsFor: 'accessing-description' stamp: 'lr 2/1/2007 19:47'!
descriptionLanguage
	^ (MASingleOptionDescription selector: #language label: 'Language' priority: 160)
		comment: 'The language the channel is written in.';
		reference: (MAStringDescription new
			stringWriter: self;
			yourself);
		options: self languages keys;
		default: 'en';
		beRequired;
		beEditable;
		beSorted;
		yourself! !

!PBBlog class methodsFor: 'accessing-description' stamp: 'lr 1/26/2007 00:52'!
descriptionManagingEditor
	^ (MAStringDescription selector: #managingEditor label: 'Managing Editor' priority: 130)
		comment: 'Email address for person responsible for editorial content.';
		beEditable;
		yourself! !

!PBBlog class methodsFor: 'accessing-description' stamp: 'lr 1/26/2007 00:52'!
descriptionWebMaster
	^ (MAStringDescription selector: #webMaster label: 'Web Master' priority: 140)
		comment: 'Email address for person responsible for technical issues relating to channel.';
		beEditable;
		yourself! !

!PBBlog class methodsFor: 'accessing-resources' stamp: 'lr 2/12/2007 19:07'!
icon
	"PRCompatibility compileFileNamed: 'icons/blog.png' into: PBBlog class selector: #icon"

	^ #(137 80 78 71 13 10 26 10 0 0 0 13 73 72 68 82 0 0 0 14 0 0 0 14 8 6 0 0 0 31 72 45 209 0 0 0 4 103 65 77 65 0 0 175 200 55 5 138 233 0 0 0 25 116 69 88 116 83 111 102 116 119 97 114 101 0 65 100 111 98 101 32 73 109 97 103 101 82 101 97 100 121 113 201 101 60 0 0 2 67 73 68 65 84 120 218 140 146 77 72 20 97 24 199 127 243 206 204 206 180 49 69 34 219 22 230 33 161 72 68 42 195 40 242 150 135 80 161 75 116 16 235 80 135 110 158 250 184 69 208 165 58 175 7 111 65 65 72 5 66 82 17 81 212 33 131 252 202 200 37 138 172 214 66 212 93 221 252 216 221 249 234 153 89 20 234 212 59 243 12 207 251 206 243 127 158 247 121 254 127 237 115 23 233 16 6 131 144 52 176 73 131 64 147 143 188 255 174 245 163 25 177 14 35 2 169 244 238 214 146 27 80 115 252 12 90 185 72 144 255 10 115 89 76 75 199 178 20 122 100 166 142 82 129 96 130 84 238 217 228 144 17 134 236 245 66 13 189 126 31 59 187 175 253 85 98 245 253 35 220 225 12 186 159 199 52 21 232 98 94 41 250 117 192 144 107 41 67 50 26 134 207 204 157 75 104 74 146 108 77 145 108 104 193 105 238 4 177 202 232 109 130 241 126 148 38 64 101 197 73 141 168 182 50 53 188 197 239 132 11 14 184 5 130 31 75 44 77 13 176 242 177 141 109 71 207 97 29 60 139 155 176 225 93 31 97 224 111 0 37 11 132 181 245 212 245 222 143 183 165 47 175 113 39 239 81 202 189 98 118 240 3 169 174 91 216 77 167 41 191 21 96 113 126 29 2 102 66 134 144 240 89 120 145 97 113 100 0 187 161 13 231 100 6 103 255 41 172 66 150 249 199 87 171 77 55 245 72 139 94 21 24 205 216 222 108 226 80 64 141 244 81 122 122 153 153 254 14 214 166 223 96 31 187 72 178 174 5 47 55 74 254 101 6 235 240 121 220 74 149 21 37 252 17 132 21 130 210 28 134 87 192 177 92 18 249 73 102 31 246 198 1 137 214 11 32 109 149 243 191 226 125 88 211 88 5 250 2 92 94 43 96 180 95 199 185 242 19 171 253 6 182 92 157 226 44 197 177 7 88 123 218 209 236 237 184 43 203 49 192 55 106 54 128 154 43 78 178 241 68 117 90 205 221 40 225 53 226 201 93 152 142 207 116 187 54 174 26 251 233 166 106 156 46 60 38 109 157 213 236 19 182 28 234 193 157 184 43 65 26 150 82 4 217 231 228 167 199 133 158 41 252 194 10 185 155 221 172 78 12 163 71 250 251 212 201 104 234 200 174 3 136 164 52 121 116 169 22 200 21 188 178 80 90 145 254 197 42 107 226 139 96 252 114 52 77 31 237 247 183 49 77 68 190 67 18 12 69 50 226 255 214 88 36 242 63 2 12 0 161 205 214 237 154 234 71 98 0 0 0 0 73 69 78 68 174 66 96 130) asByteArray! !

!PBBlog class methodsFor: 'testing' stamp: 'lr 1/15/2007 22:02'!
isAbstract
	^ false! !

!PBBlog class methodsFor: 'accessing-resources' stamp: 'lr 1/26/2007 00:48'!
languages
	^ Languages ifNil: [ Languages := self buildLanguages ]! !

!PBBlog class methodsFor: 'private' stamp: 'lr 1/26/2007 00:47'!
write: anObject description: aDescription
	^ self languages at: anObject ifAbsent: [ anObject ]! !

!PBBlog methodsFor: 'visiting' stamp: 'lr 1/15/2007 20:05'!
accept: aVisitor
	aVisitor visitBlog: self! !

!PBBlog methodsFor: 'accessing-dynamic' stamp: 'lr 2/12/2007 19:07'!
allCommentsIn: aContext
	"Answer all the comments in choronological order."

	^ ((aContext enumeratorFor: self) all
		select: [ :each |
			each isComment
				and: [ each publication notNil
				and: [ each publication <= TimeStamp now ] ] ])
		sort: [ :a :b | a publication < b publication ]! !

!PBBlog methodsFor: 'accessing-dynamic' stamp: 'lr 2/12/2007 19:07'!
allPostsIn: aContext
	"Answer all the published posts in choronological order."

	^ ((aContext enumeratorFor: self)
		select: [ :each |
			each isPost
				and: [ each publication notNil
				and: [ each publication <= TimeStamp now ] ] ])
		sort: [ :a :b | a publication < b publication ]! !

!PBBlog methodsFor: 'accessing' stamp: 'lr 2/20/2007 15:23'!
commentTimeout
	^ commentTimeout ifNil: [ commentTimeout := 14 days ]! !

!PBBlog methodsFor: 'accessing' stamp: 'lr 2/6/2007 19:45'!
commentTimeout: aDuration
	commentTimeout := aDuration! !

!PBBlog methodsFor: 'accessing' stamp: 'lr 1/19/2007 19:18'!
copyright
	^ copyright! !

!PBBlog methodsFor: 'accessing' stamp: 'lr 1/19/2007 19:18'!
copyright: aString
	copyright := aString! !

!PBBlog methodsFor: 'accessing' stamp: 'lr 2/1/2007 19:45'!
feedTitle
	^ feedTitle! !

!PBBlog methodsFor: 'accessing' stamp: 'lr 2/1/2007 19:41'!
feedTitle: aString
	feedTitle := aString! !

!PBBlog methodsFor: 'testing' stamp: 'lr 1/15/2007 21:06'!
isBlog
	^ true! !

!PBBlog methodsFor: '*pier-blog-seaside' stamp: 'lr 1/29/2007 13:50'!
isValidView: aComponentClass in: aContext
	^ super viewComponentClass ~= aComponentClass! !

!PBBlog methodsFor: 'accessing' stamp: 'lr 2/1/2007 19:40'!
itemCount
	^ itemCount ifNil: [ itemCount := 10 ]! !

!PBBlog methodsFor: 'accessing' stamp: 'lr 2/1/2007 19:41'!
itemCount: anInteger
	itemCount := anInteger! !

!PBBlog methodsFor: 'accessing' stamp: 'lr 1/26/2007 00:33'!
language
	^ language! !

!PBBlog methodsFor: 'accessing' stamp: 'lr 1/26/2007 00:54'!
language: aString
	language := aString! !

!PBBlog methodsFor: 'accessing' stamp: 'lr 1/18/2007 00:16'!
managingEditor
	^ managingEditor! !

!PBBlog methodsFor: 'accessing' stamp: 'lr 1/18/2007 00:17'!
managingEditor: anEditor
	managingEditor := anEditor! !

!PBBlog methodsFor: '*pier-blog-seaside' stamp: 'lr 2/5/2007 19:38'!
viewComponentClass
	^ PBBlogHtmlView! !

!PBBlog methodsFor: 'accessing' stamp: 'lr 1/18/2007 00:17'!
webMaster
	^ webMaster! !

!PBBlog methodsFor: 'accessing' stamp: 'lr 1/18/2007 00:17'!
webMaster: aString
	webMaster := aString! !

PRCase subclass: #PBEntry
	instanceVariableNames: 'uuid author publication'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Blog-Model'!

PBEntry subclass: #PBComment
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Blog-Model'!

!PBComment class methodsFor: 'testing' stamp: 'lr 1/15/2007 20:04'!
canBeChildOf: aClass
	^ aClass includesBehavior: PBPost! !

!PBComment class methodsFor: 'testing' stamp: 'lr 1/15/2007 20:04'!
canBeParentOf: aClass
	^ false! !

!PBComment class methodsFor: 'accessing-descriptions' stamp: 'lr 2/12/2007 19:07'!
descriptionAuthor
	^ super descriptionAuthor
		propertyAt: #public put: true;
		beRequired;
		yourself! !

!PBComment class methodsFor: 'accessing-descriptions' stamp: 'lr 2/9/2007 01:21'!
descriptionContents
	^ super descriptionContents
		propertyAt: #public put: true;
		beRequired;
		yourself! !

!PBComment methodsFor: 'visiting' stamp: 'lr 1/15/2007 16:08'!
accept: aVisitor
	aVisitor visitComment: self! !

!PBComment methodsFor: 'initialization' stamp: 'lr 2/6/2007 20:14'!
initialize
	super initialize.
	self publication: TimeStamp now! !

!PBComment methodsFor: 'testing' stamp: 'lr 1/14/2007 13:23'!
isComment
	^ true! !

!PBEntry class methodsFor: 'accessing-descriptions' stamp: 'lr 2/1/2007 20:24'!
descriptionAuthor
	^ (MAStringDescription selector: #author label: 'Author' priority: 110)
		comment: 'The author of the entry.';
		beEditable;
		yourself! !

!PBEntry class methodsFor: 'accessing-descriptions' stamp: 'lr 2/9/2007 01:26'!
descriptionPublication
	^ (MATimeStampDescription selector: #publication label: 'Publication' priority: 120)
		comment: 'The publication date of the entry.';
		beEditable;
		yourself! !

!PBEntry class methodsFor: 'testing' stamp: 'lr 1/14/2007 12:36'!
isAbstract
	^ self name = #PBEntry! !

!PBEntry methodsFor: 'visiting' stamp: 'pmm 1/26/2007 23:34'!
accept: aVisitor
	aVisitor visitEntry: self! !

!PBEntry methodsFor: 'accessing-dynamic' stamp: 'lr 2/12/2007 19:07'!
allCommentsIn: aContext
	"Answer all the published comments in choronological order."

	^ ((aContext enumeratorFor: self) all
		select: [ :each |
			each isComment
				and: [ each publication notNil
				and: [ each publication <= TimeStamp now ] ] ])
		sort: [ :a :b | a publication < b publication ]! !

!PBEntry methodsFor: 'accessing' stamp: 'lr 1/26/2007 01:00'!
author
	^ author! !

!PBEntry methodsFor: 'accessing' stamp: 'lr 1/14/2007 12:36'!
author: aString
	author := aString! !

!PBEntry methodsFor: 'accessing' stamp: 'lr 1/19/2007 18:40'!
publication
	^ publication! !

!PBEntry methodsFor: 'accessing' stamp: 'lr 1/19/2007 18:40'!
publication: aTimeStamp
	publication := aTimeStamp! !

!PBEntry methodsFor: 'accessing' stamp: 'lr 2/6/2007 20:20'!
uuid
	^ uuid ifNil: [ uuid := SmallInteger maxVal atRandom asString ]! !

!PBEntry methodsFor: 'accessing' stamp: 'lr 2/6/2007 20:12'!
uuid: anObject
	uuid := anObject! !

PBEntry subclass: #PBPost
	instanceVariableNames: 'sourceUrl sourceTitle enclosure'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Blog-Model'!

!PBPost class methodsFor: 'testing' stamp: 'lr 1/15/2007 22:02'!
canBeChildOf: aClass
	^ aClass includesBehavior: PBBlog! !

!PBPost class methodsFor: 'accessing-descriptions' stamp: 'lr 2/9/2007 01:26'!
descriptionEnclosure
	^ (PRStructureDescription selector: #enclosure label: 'Enclosure' priority: 150)
		addCondition: [ :value | value isFile ] asCondition labelled: 'Enclosure must be a file';
		comment: 'A media object that is attached to the item.';
		beEditable;
		yourself! !

!PBPost class methodsFor: 'accessing-descriptions' stamp: 'lr 2/9/2007 01:26'!
descriptionSourceTitle
	^ (MAStringDescription selector: #sourceTitle label: 'Source Title' priority: 130)
		comment: 'The title of the RSS channel that the item came from.';
		beEditable;
		yourself! !

!PBPost class methodsFor: 'accessing-descriptions' stamp: 'lr 2/9/2007 01:26'!
descriptionSourceUrl
	^ (MAStringDescription selector: #sourceUrl label: 'Source URL' priority: 140)
		comment: 'The url of the RSS channel that the item came from.';
		beEditable;
		yourself! !

!PBPost methodsFor: 'visiting' stamp: 'lr 1/15/2007 16:08'!
accept: aVisitor
	aVisitor visitPost: self! !

!PBPost methodsFor: 'accessing' stamp: 'lr 1/27/2007 18:30'!
enclosure
	^ enclosure! !

!PBPost methodsFor: 'accessing' stamp: 'lr 2/12/2007 19:07'!
enclosure: aFile
	enclosure := aFile! !

!PBPost methodsFor: 'testing' stamp: 'lr 1/14/2007 13:44'!
isPost
	^ true! !

!PBPost methodsFor: '*pier-blog-seaside' stamp: 'lr 1/29/2007 13:50'!
isValidView: aComponentClass in: aContext
	^ super viewComponentClass ~= aComponentClass! !

!PBPost methodsFor: 'accessing' stamp: 'pmm 1/26/2007 18:07'!
sourceTitle
	^sourceTitle! !

!PBPost methodsFor: 'accessing' stamp: 'lr 2/12/2007 19:07'!
sourceTitle: aString
	sourceTitle := aString! !

!PBPost methodsFor: 'accessing' stamp: 'pmm 1/26/2007 18:07'!
sourceUrl
	^sourceUrl! !

!PBPost methodsFor: 'accessing' stamp: 'lr 2/12/2007 19:07'!
sourceUrl: aString
	sourceUrl := aString! !

!PBPost methodsFor: '*pier-blog-seaside' stamp: 'lr 2/5/2007 19:38'!
viewComponentClass
	^ PBPostHtmlView! !

PRDefaultView subclass: #PBHtmlView
	instanceVariableNames: 'blog'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Blog-Seaside'!

PBHtmlView subclass: #PBBlogHtmlView
	instanceVariableNames: 'posts batcher'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Blog-Seaside'!

!PBBlogHtmlView class methodsFor: 'testing' stamp: 'lr 1/15/2007 21:05'!
isAbstract
	^ false! !

!PBBlogHtmlView class methodsFor: 'testing' stamp: 'lr 1/19/2007 19:13'!
isValidIn: aContext
	^ (super isValidIn: aContext) and: [ aContext structure isBlog ]! !

!PBBlogHtmlView methodsFor: 'accessing' stamp: 'lr 2/5/2007 19:27'!
batcher
	^ batcher ifNil: [ batcher := WABatchedList new items: self posts; batchSize: 5 ]! !

!PBBlogHtmlView methodsFor: 'accessing' stamp: 'lr 2/5/2007 19:25'!
children
	^ Array with: self batcher! !

!PBBlogHtmlView methodsFor: 'private' stamp: 'lr 2/5/2007 19:24'!
findPosts
	^ (self blog allPostsIn: self context) reversed! !

!PBBlogHtmlView methodsFor: 'accessing' stamp: 'lr 2/3/2007 18:08'!
posts
	^ posts ifNil: [ posts := self findPosts ]! !

!PBBlogHtmlView methodsFor: 'rendering' stamp: 'lr 2/5/2007 19:30'!
renderBatcherOn: html
	(self batcher isOnFirstPage and: [ self batcher isOnLastPage ])
		ifFalse: [ html div class: 'batcher'; with: self batcher ]! !

!PBBlogHtmlView methodsFor: 'rendering' stamp: 'lr 2/5/2007 20:05'!
renderContentOn: html
	super renderContentOn: html.
	self renderPosts: self batcher batch on: html.
	self renderBatcherOn: html.
	self renderRssOn: html! !

!PBBlogHtmlView methodsFor: 'rendering' stamp: 'lr 2/12/2007 19:07'!
renderPosts: aCollection on: html
	html div class: 'posts'; with: [
		self batcher batch do: [ :each |
			html heading
				level: 2;
				with: each title.
			self render: each on: html ] ]! !

!PBHtmlView class methodsFor: 'testing' stamp: 'lr 2/5/2007 19:55'!
isAbstract
	^ true! !

!PBHtmlView methodsFor: 'accessing' stamp: 'lr 2/5/2007 19:35'!
blog
	^ blog ifNil: [ blog := self find: PBBlog ]! !

!PBHtmlView methodsFor: 'rendering' stamp: 'lr 2/12/2007 19:07'!
renderRssOn: html
	html div class: 'subscribe'; with: [
		html anchor
			url: (self context
				structure: self blog
				view: PBEntriesRssView)
					url;
			with: 'Entries (RSS)'.
		html text: ' and '.
		html anchor
			url: (self context
				structure: self blog
				view: PBCommentsRssView)
					url;
			with: 'Comments (RSS)' ]! !

!PBHtmlView methodsFor: 'updating' stamp: 'lr 2/6/2007 18:07'!
updateRoot: aHtmlRoot
	super updateRoot: aHtmlRoot.
	aHtmlRoot rss
		title: self blog feedTitle;
		url: (self context
			structure: self blog
			view: PBEntriesRssView)
				url! !

PBHtmlView subclass: #PBPostHtmlView
	instanceVariableNames: 'post comment command component'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Blog-Seaside'!

!PBPostHtmlView class methodsFor: 'testing' stamp: 'lr 1/29/2007 13:37'!
isAbstract
	^ false! !

!PBPostHtmlView class methodsFor: 'testing' stamp: 'lr 1/29/2007 13:37'!
isValidIn: aContext
	^ (super isValidIn: aContext) and: [ aContext structure isPost ]! !

!PBPostHtmlView methodsFor: 'private' stamp: 'lr 2/12/2007 19:07'!
buildCommand
	^ (self context
		structure: self comment
		command: self comment editCommandClass new)
			command! !

!PBPostHtmlView methodsFor: 'private' stamp: 'lr 2/20/2007 15:15'!
buildComment
	^ PBComment new
		title: self context structure title;
		yourself! !

!PBPostHtmlView methodsFor: 'private' stamp: 'lr 2/9/2007 01:23'!
buildComponent
	^ (self buildDescription asComponentOn: self command)
		onAnswer: [ :result | self execute: result ];
		addValidatedForm;
		yourself! !

!PBPostHtmlView methodsFor: 'private' stamp: 'lr 2/12/2007 19:07'!
buildDescription
	^ self command description select: [ :each |
		each
			propertyAt: #public
			ifAbsent: [ false ] ]! !

!PBPostHtmlView methodsFor: 'accessing' stamp: 'lr 1/29/2007 13:57'!
children
	^ Array with: self component! !

!PBPostHtmlView methodsFor: 'accessing' stamp: 'lr 1/29/2007 14:56'!
command
	^ command ifNil: [ command := self buildCommand ]! !

!PBPostHtmlView methodsFor: 'accessing' stamp: 'lr 1/29/2007 14:57'!
comment
	^ comment ifNil: [ comment := self buildComment ]! !

!PBPostHtmlView methodsFor: 'accessing' stamp: 'lr 1/29/2007 15:11'!
comments
	^ self context structure allCommentsIn: self context! !

!PBPostHtmlView methodsFor: 'accessing' stamp: 'lr 1/29/2007 15:04'!
component
	^ component ifNil: [ component := self buildComponent]! !

!PBPostHtmlView methodsFor: 'actions' stamp: 'lr 2/20/2007 15:16'!
execute: anEditCommand
	| addCommand |
	comment := component := command := nil.
	anEditCommand ifNil: [ ^ self ].
	addCommand := PRAddCommand new.
	self context command: addCommand.
	addCommand
		name: (addCommand
			uniqueName: 'comment'
			in: self context structure);
		type: PBComment;
		beUnchecked;
		execute.
	self context 
		structure: addCommand answer structure
		command: anEditCommand.
	anEditCommand
		beUnchecked;
		execute! !

!PBPostHtmlView methodsFor: 'testing' stamp: 'lr 2/12/2007 19:07'!
isCommentEnabled
	^ self post publication notNil and: [ self post publication + self blog commentTimeout >= TimeStamp now ]! !

!PBPostHtmlView methodsFor: 'accessing' stamp: 'lr 2/6/2007 19:29'!
post
	^ post ifNil: [ post := self find: PBPost ]! !

!PBPostHtmlView methodsFor: 'rendering' stamp: 'lr 1/31/2007 18:48'!
renderCommentOn: html
	html div class: 'leavecomment'; with: [
		html heading level: 2; with: 'Leave a comment'.
		html render: self component ]! !

!PBPostHtmlView methodsFor: 'rendering' stamp: 'lr 1/31/2007 18:48'!
renderCommentsOn: html
	self comments do: [ :each | self render: each on: html ]! !

!PBPostHtmlView methodsFor: 'rendering' stamp: 'lr 2/12/2007 19:07'!
renderContentOn: html
	self render: self post on: html.
	html div class: 'comments'; with: [
		self renderCommentsOn: html.
		self isCommentEnabled
			ifTrue: [ self renderCommentOn: html ] ].
	self renderRssOn: html! !
